$(function(){
	afficher_si_init();
	onAjaxLoad(afficher_si_init);
});
afficher_si_current_data = '';
function afficher_si_init() {
	$('form:not([data-afficher_si-init])').each(function(){
		// Seulement si au moins un afficher_si dedans !
		if ($(this).find('[data-afficher_si]').length !== 0) {
			form = $(this);
			form.find('.formulaire_spip__etapes').each(function() {
				$(this).css('min-height', $(this).height());
			});
			afficher_si_set_current_data(form);
			form.find('[data-afficher_si]').each(function(){
				condition = verifier_afficher_si($(this), true);
				animer_afficher_si($(this), condition, true);
			}
			);
			afficher_si_set_etapes_presentation_courante(form);

			// Un écouteur sur la modif de tous les champs de ce form
			$(this).find('textarea, input, select').change(function(){
				// Seulement si ce champ a un name
				if (name = $(this).attr('name')) {
					form = $(this).parents('form');
					name = name.replace('[]', '');

					afficher_si_set_current_data(form);

					// Si un autre champ utilise celui-ci dans une condition
					form.find('[data-afficher_si*=\''+name+'\']').each(function(){
						condition = verifier_afficher_si($(this));
						animer_afficher_si($(this), condition);
					})
					afficher_si_set_etapes_presentation_courante(form, name);
				}
			});
			$(this).attr('data-afficher_si-init', true);
		}
	})
}
function afficher_si_set_current_data(form) {
	current_data = form.serializeArray();//Le format de retour n'est pas simple, on transforme en tableau associatif
	afficher_si_current_data = [];
	$(current_data).each(function() {
		if (this.name.includes('[]')) {
			this.name	= this.name.replace('[]', '');
			if (Array.isArray(afficher_si_current_data[this.name])) {
				afficher_si_current_data[this.name].push(this.value)
			} else {
				afficher_si_current_data[this.name] = [this.value];
			}
		} else {
			afficher_si_current_data[this.name] = this.value;
		}
	});
}
function verifier_afficher_si(saisie, chargement = false) {
	if ((saisie.hasClass('erreur') || $('.erreur', saisie).length) && chargement) {//Tjr afficher au chargement s'il y  une erreur. Si cela arrive c'est qu'il y a quelque part une incohérence entre l'évaluation JS et l'évaluation PHP des afficher si.
		console.log('Attention : saisies masquée par afficher_si avec une erreur...' + saisie.attr('data-id'));
		return true;
	}
	condition = saisie.attr('data-afficher_si');
	condition = eval(condition);
	return condition
}
function animer_afficher_si(saisie, condition, chargement){
	if (condition) {
		if (!saisie.hasClass('afficher_si_visible')) {
			saisie.trigger('afficher_si_visible_pre');
			saisie.removeClass('afficher_si_masque_chargement').removeClass('afficher_si_masque').addClass('afficher_si_visible').removeAttr('aria-hiden');
			if (!saisie.hasClass('etapes__item')) {
				afficher_si_show(saisie);
			}
			saisie.find('[data-afficher-si-required]').attr('required', true).attr('data-afficher-si-required',false);
			saisie.trigger('afficher_si_visible_post');
		}
	} else {
		if (!saisie.hasClass('afficher_si_masque')) {
			saisie.trigger('afficher_si_masque_pre');
			if (!saisie.hasClass('etapes__item')) {
				afficher_si_hide(saisie);
			}
			if (chargement) {
				saisie.addClass('afficher_si_masque_chargement');
			}
			saisie.addClass('afficher_si_masque').removeClass('afficher_si_visible').attr('aria-hiden', true);
			saisie.find('[required]').attr('required', false).attr('data-afficher-si-required', null);
			saisie.trigger('afficher_si_masque_post');
		}
	}
}
//Pour l'affichage des étapes selon la présentation "étape courante" seulement
function afficher_si_set_etapes_presentation_courante(form, name='') {
	form.find('.formulaire_spip__etapes--courante[data-afficher_si-etapes-futures]').each(function() {
		afficher_si_etapes = JSON.parse($(this).attr('data-afficher_si-etapes-futures'));
		etape_total = $(this).attr('data-etapes_max');
		for (etape in afficher_si_etapes) {
			condition = afficher_si_etapes[etape];
			if (!name || condition.includes(name)) {
				$(this).attr('data-' + etape, eval(condition));
			}
			if (condition && !eval($(this).attr('data-' + etape))) {
				etape_total--;
			}
		}
		$(this).find('.formulaire_spip_etape__total').text(etape_total);
	});
}

function afficher_si(args) {
	if (afficher_si_current_data.hasOwnProperty(args['champ'])) {
		valeur_champ = afficher_si_current_data[args['champ']];
	} else {
		valeur_champ = '';
	}
	valeur = args['valeur'];

	// Compat historique == > IN pour données tabulaires !
	if (Array.isArray(valeur_champ) && !args['total']) {
		if (args['operateur'] == '==') {
			args['operateur'] = 'IN';
		} else if(args['operateur'] == '!=') {
			args['operateur'] = '!IN';
		}
	}
	// Si on vérifie un total
	if (args['total']) {
		if (Array.isArray(valeur_champ)) {
			valeur_champ = valeur_champ.length;
		} else {
			valeur_champ = 0;
		}
	}

	// Transformation en tableau des valeurs et valeur_champ, si IN/!IN
	if (args['operateur'] == 'IN' || args['operateur'] == '!IN') {
		valeur = valeur.split(',');
		if (!Array.isArray(valeur_champ)) {
			if (valeur_champ) {
				valeur_champ = [valeur_champ];
			} else {
				valeur_champ = [];
			}
		}
	}

	// Transformation en entier des valeurs et valeur_champ, si opérateur de comparaison
	if (['<', '<=', '>=', '>'].includes(args['operateur'])) {
		valeur = Number(valeur);
		valeur_champ = Number(valeur_champ);
	}

	// Et maintenant les test
	switch (args['operateur']) {
		case '==':
			return valeur_champ == valeur;
		case '!=':
			return valeur_champ != valeur;
		case '>':
			return valeur_champ > valeur;
		case '>=':
			return valeur_champ >= valeur;
		case '<':
			return valeur_champ < valeur;
		case '<=':
			return valeur_champ <= valeur;
		case 'MATCH':
			return RegExp(valeur, args.regexp_modif).test(valeur_champ);
		case 'MATCH':
			return !RegExp(valeur, args.regexp_modif).test(valeur_champ);
		case 'IN':
			return $(valeur).filter(valeur_champ).length ? true : false;
		case '!IN':
			return $(valeur).filter(valeur_champ).length ? false : true;
		default:
			return valeur_champ ? true : false;
	}
}

